package cn.iocoder.yudao.module.ecw.dal.dataobject.currencyRate;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.type.JsonLongSetTypeHandler;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.ToString;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Set;

/**
 * 货币汇率变更历史 DO
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName(value = "ecw_currency_rate_log", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CurrencyRateLogDO extends BaseDO {
    /**
     *
     */
    @TableId
    private Long id;

    /**
     * 汇率编号
     */
    private Long rateId;

    /**
     * 原币种变更前金额
     */
    private BigDecimal sourceAmount1;

    /**
     * 原币种变更后金额
     */
    private BigDecimal sourceAmount2;

    /**
     * 支付币种变更前金额
     */
    private BigDecimal targetAmount1;

    /**
     * 支付币种变更后金额
     */
    private BigDecimal targetAmount2;

    /**
     * 国家变更前
     */
    @TableField(typeHandler = JsonLongSetTypeHandler.class)
    private Set<Long> countries1;

    /**
     * 国家变更后
     */
    @TableField(typeHandler = JsonLongSetTypeHandler.class)
    private Set<Long> countries2;

    /**
     * 有效期
     */
    private Date expiration1;

    /**
     * 有效期
     */
    private Date expiration2;

    /**
     * 备注
     */
    private String remarks;
}
